Subject: bug#62951: 29.0.90; c-ts-mode: Incorrect fontification due to FOR_EACH_TAIL_SAFE

From: Eli Zaretskii <[email-masked]>
Date: Fri, 28 Apr 2023 08:41:53 +0300

> From: Yuan Fu <[email-masked]>
> Date: Thu, 27 Apr 2023 12:56:07 -0700
> Cc: [email-masked],
>  [email-masked]
> 
> >  c-ts-mode: Cannot load language definition: not-found, ("libtree-sitter-emacs-c" "libtree-sitter-emacs-c.dll"), "No such file or directory"
> > 
> > It looks like your "fake emacs-c language" trick somehow misfires?
> > The value of treesit-load-name-override-list is nil, which is not what
> > you intended, AFAICT?  The only way I can make this work is by
> > manually customizing treesit-load-name-override-list before loading
> > c-ts-mode.
> 
> Duh, sorry, dumb mistake. Fixed.

Thanks.

> > Otherwise, looks quite good; here are some other problems I found:
> > 
> >  . some uses of FOR_EACH_TAIL are not fontified at all; examples:
> >    comp.c, line 2079, fns.c, line 189
> 
> You mean the FOE_EACH_TAIL part isn’t fontified, or the body isn’t fontified? Because the body are always fontified here. FOR_EACH_TAIL itself shouldn’t be fontified since it’s just a macro call and a variable.

I mean the macro itself, FOR_EACH_TAIL.  If it isn't supposed to be
fontified, then why is it fontified at line 856 of comp.c?  It's
inconsistent.  (However, this is a very minor problem, so if fixing
it is difficult, we can leave this alone for now.)

> >  . FOR_EACH_LIVE_BUFFER (data.c, line 1430) is not recognized?
> >  . FOR_EACH_FRAME (keyboard.c, line 1256) is not recognized?
> 
> Didn’t know that they exited :-) Now I have FOR_EACH_TAIL, FOR_EACH_TAIL_SAFE, FOR_EACH_ALIST_VALUE, FOR_EACH_LIVE_BUFFER, FOR_EACH_FRAME.

Great, thanks.

> > This is much better than before already, so I think you should install
> > this on the emacs-29 branch, once you fix the above problems (assuming
> > they are easily fixable).
> 
> Cool, I pushed the change.

Thanks.